Page MenuHomePhabricator

Terminology compilation is broken with efl 1.20.7
Closed, ResolvedPublic

Description

Compilation with efl 1.20.7 on arch linux is failing with edje complaining about offscale keyword.

Log:

[godfath3r@skynet terminology]$ meson build
The Meson build system
Version: 0.45.0
Source dir: /home/godfath3r/src/terminology
Build dir: /home/godfath3r/src/terminology/build
Build type: native build
Project name: terminology
Native C compiler: ccache cc (gcc 7.3.0 "cc (GCC) 7.3.0")
Build machine cpu family: x86_64
Build machine cpu: x86_64
Library intl found: NO
Found pkg-config: /usr/bin/pkg-config (0.29.2)
Native dependency edje found: YES 1.20.7
Native dependency elementary found: YES 1.20.7
Native dependency eina found: YES 1.20.7
Native dependency eet found: YES 1.20.7
Native dependency evas found: YES 1.20.7
Native dependency ecore found: YES 1.20.7
Native dependency ecore-evas found: YES 1.20.7
Native dependency ecore-file found: YES 1.20.7
Native dependency emotion found: YES 1.20.7
Native dependency ecore-input found: YES 1.20.7
Native dependency ecore-imf found: YES 1.20.7
Native dependency ecore-imf-evas found: YES 1.20.7
Native dependency ecore-ipc found: YES 1.20.7
Native dependency efreet found: YES 1.20.7
Native dependency ecore-con found: YES 1.20.7
Native dependency ethumb_client found: YES 1.20.7
Checking for function "mkstemps": YES
Message: Checking for ecore_con_url_head: Found
Message: Fuzzing is disabled
Message: edje_cc set to:/usr/bin/edje_cc
Configuring terminology_config.h using configuration
Program meson_install_themes.sh found: YES (/home/godfath3r/src/terminology/meson_install_themes.sh)
Build targets in project: 21
Found ninja-1.8.2 at /usr/bin/ninja
[godfath3r@skynet build]$ ninja
[1/73] Generating default.edj with a custom command.
FAILED: data/themes/default.edj
/usr/bin/edje_cc -id /home/godfath3r/src/terminology/data/themes/images -fd /home/godfath3r/src/terminology/data/fonts -sd /home/godfath3r/src/terminology/data/themes/sounds ../data/themes/default.edc data/themes/default.edj
edje_cc: Error. ../data/themes/default.edc:700 unhandled keyword offscale
edje_cc: Error. PARSE STACK:
collections.group.parts.part.description.offscale
edje_cc: Error. PARAMS:
[3/73] Generating black.edj with a custom command.
ninja: build stopped: subcommand failed.
[godfath3r@skynet build]$ which edje_cc
/usr/bin/edje_cc
[godfath3r@skynet build]$ edje_cc -V
Version: 1.20.7
godfath3r triaged this task as Normal priority.
Herald closed this task as Invalid. · View Herald TranscriptMar 11 2018, 4:25 PM
Herald added a project: Restricted Project. · View Herald Transcript

The Enlightenment ticket system is currently receiving high amounts of spam tickets. This ticket has been closed as spam because it lacks both a project and an assignee. If this ticket is not spam, please reopen it after adding these items.

godfath3r reopened this task as Open.Mar 11 2018, 4:25 PM
godfath3r edited projects, added Terminology; removed Restricted Project.

If this: https://phab.enlightenment.org/rEFLcda9532f446b1f465a6bc478e3a7d29a79b3573b is the only commit that enables offscale keyword, it is missing from v1.20.7 tag.

[godfath3r@skynet efl]$ git checkout tags/v1.20.7
Note: checking out 'tags/v1.20.7'.

You are in 'detached HEAD' state. You can look around, make experimental
changes and commit them, and you can discard any commits you make in this
state without impacting any branches by performing another checkout.

If you want to create a new branch to retain commits you create, you may
do so (now or later) by using -b with the checkout command again. Example:

  git checkout -b <new-branch-name>

HEAD is now at df5525b67e elm_code: Fix line selection with leading tabs
[godfath3r@skynet efl]$ git log | grep cda9532f446 -A 4
[godfath3r@skynet efl]$

[godfath3r@skynet efl]$ git checkout master
Previous HEAD position was df5525b67e elm_code: Fix line selection with leading tabs
Switched to branch 'master'
Your branch is up to date with 'origin/master'.
[godfath3r@skynet efl]$ git log | grep cda9532f446 -A 4
commit cda9532f446b1f465a6bc478e3a7d29a79b3573b
Author: Carsten Haitzler (Rasterman) <raster@rasterman.com>
Date:   Mon Oct 30 17:01:39 2017 +0900

    edje_cc - add offset_scale/offscale per desc to allow offsets to scale
[godfath3r@skynet efl]$
zmike added a subscriber: zmike.Mar 12 2018, 2:18 PM

You should be able to just do #ifdef EFL_VERSION_1_21 around this within edc files? This define is added to git immediately following a major release...

Long time ago, this macro was not defined and since then I prefer to have feature detection.

zmike added a comment.Mar 13 2018, 7:28 AM

Yes, I did only start adding it during the 1.18 development cycle, but that means it should be possible to use it for any features added since that time. Just trying to provide some info which could be useful for future cases!

Great that you do that!
I wasn't aware of it. I got bitten in the past and thus relied on feature detection.